#pragma once

#include "IPC/IPCCopyData.h"
#include <ATLPath.h>
#include "Packet.h"
#include "IModule.h"
using namespace tipbase;

class LauncherManager
{
public:
	static LauncherManager* GetInstance()
	{
		static LauncherManager launcher;
		return &launcher;
	}

	BOOL CheckLauncher()
	{
		IPCStringKey key( GetLauncherName() );
		IPCCopyDataHandle* launcherHandle = (IPCCopyDataHandle*)m_server.Find( &key );
		if( NULL == launcherHandle )
		{
			ATLTRACE(_T("launcherhandle error\n"));
			return FALSE;
		}

		return TRUE;
	}

	BOOL KillLauncher()
	{
		IPCStringKey key(m_launcherName);

		IIPCHandle* launcherHandle = m_server.Find( &key );
		if( NULL == launcherHandle )
		{
			return FALSE;
		}

		ProtocolPacketHeader packet;
		packet.type = PacketCommand_Quit;
		launcherHandle->Write( (const BYTE *)&packet, sizeof(ProtocolPacketHeader));
		launcherHandle->Close();
		delete launcherHandle;
		return TRUE;
	}

	void SetLaucnherName( const TCHAR *launcherName )
	{
		m_launcherName = launcherName;
	}

	const TCHAR *GetLaucnherName()
	{
		return m_launcherName;
	}

	IIPCHandle *GetLauncherHandle()
	{
		IPCStringKey key(GetLauncherName());
		return m_server.Find( &key );
	}

	BOOL StartLauncher( const TCHAR *launcherName )
	{
		SetLaucnherName(launcherName);
		TCHAR path[1024];
		// [:2008-09-22] α׷    ʾƼ 
		//GetCurrentDirectory( 1024, path );
		GetModuleFileName(NULL, path, 1024);
		ATLPath::RemoveFileSpec(path);
#ifdef _DEBUG
		ATLPath::Append( path, _T("NToolsLauncherD.exe") );
#else
		ATLPath::Append( path, _T("NToolsLauncher.exe") );
#endif
/*
		CString launcherPath;
		launcherPath = path;
		launcherPath += '\\';
		launcherPath += _T("TipLauncher.exe");
*/
		BOOL ret = ExecProgram(path, launcherName );
		if( TRUE == ret )
		{
			_sleep(1000);
			CString hostname = GetLaucnherName();
			hostname += _T("_host");
			IPCStringKey host(hostname);
			if ( false == m_server.Create(&host) )
				return FALSE;
		}

		return ret;
	}

private:
	CString m_launcherName;
	IPCCopyDataServer m_server;
};